'non-heinous trace facilities'
#
#  LGPL - don't steal, don't sue
#

import os, pwd, string, Tkinter, sys


#
# runs a UI for a privileged few, or nukes it to keep the test browser going
#
def maybeMainloop(users, root, frame):
	user = pwd.getpwuid(os.getuid())[0]

	if user in users:
#		centerWindow(frame)

		def quitFrame(event, frame = frame):
			frame.quit()

		frame.bind('<Destroy>', quitFrame)

		Tkinter.mainloop()
	else:
		root.destroy()
		frame.destroy()

	return


def printDocString(thing):
	dok = None

	try:
		dok = thing.__doc__
	except: pass  #  whatEver

	if dok == None:
		dok = ''

	print '"' + dok + '"'

	return


def showAllMethods(klassList):
	for klass in klassList:
		for z, funk in klass.__dict__.items():
			print klass.__name__ + "." + z,
			printDocString(funk)

		showAllMethods(klass.__bases__)


#
# prints out the dir() for any object in a pretty format.
#
def inspectObject(obj):
	printDocString(obj)
	klass = obj.__class__

	try:
		print "(" + klass.__name__ + ")"
	except(AttributeError):
		pass

	printDocString(klass)

	# TODO: call inspectObject on each member?

	for z in dir(obj):
		print "." + z, repr(getattr(obj, z))

	showAllMethods([klass])
	return


#
#  alias for "rm -f"
#
def zilchFile (fileName):
	try: os.remove (fileName)
	except OSError:  pass

#
#  print your expression and its evaluation as an error with a 
#  line:num: decoration so the Test Browser can surf to it
#
def db(*expr):

	from string import count
	try: raise None
	except:
# TODO is there an inspect.py frame thing we could use here?
		try:
			info = sys.exc_info()
			tb = info[2]
			frame = tb.tb_frame.f_back
			code = frame.f_code
			file = [None, None]

			# read this test file only once
			if file[0] != code.co_filename:
				file[0] = code.co_filename
				f = open(file[0])
				file[1] = f.read()
				f.close()

			#
			# parse the file to output the failed condition
			#

			# skip over to the 'TEST' line
			index = 0
			for i in range(frame.f_lineno - 1):
				index = string.find(file[1], '\n', index) + 1

			# capture the argument text to the 'TEST' call
			# balancing out paren's
			net = 0
			output = ''
			space = 0
			while 1:
				if (file[1][index] == '('):
					net = net + 1

				if net:
					char = file[1][index]

					# skip over whitespaces
					if (char in string.whitespace):
						if (space):
							char = ''
						else:
							char = ' '
							space = 1
					else:
						space = 0
					output = output + char

				if (file[1][index] == ')'):
					net = net - 1

				if ((not net) and output):
					break;

				index = index + 1

			stringThing = ""
			
			for e in expr:
				if stringThing != "":  stringThing += ","
				stringThing += repr (e)
			
			if len(expr) > 1:  stringThing = "(" + stringThing + ")"
			report = '%s:%i: %s' % (file[0], frame.f_lineno, output)

			if count (stringThing, "\n") > 0:
				report += " =\n",
			else:
				report += " = ",

				report += stringThing
				
			sys.stderr(report)
			print report
		except:
			pass


def tolerance(a, b):
	small = None

	try:
		small = a / 1000.0
	except TypeError:
		return a == b  #  they ain't numbers

	if small != None:
		small = abs(small)
		if small < 0.00001:  small = 0.00001
		absdiff = abs(a - b)
		got = absdiff < small
		return got


def tolerances(as, bs):
	assert len(as) == len(bs)

	for idx in range(len(as)):
		if not tolerance (as[idx], bs[idx]):
			print repr(as)
			print repr(bs)
			return 0

	return 1



